<?php
/*
Plugin Name: Anyfeed Slideshow
Plugin URI: http://tixen.net/projects/anyfeed-slideshow/
Description: A quick and easy jQuery based slideshow widget, fed from absolutely any XML/RSS/ATOM feed that contains images!
Version: 1.0.6
Author: Soleil Golden
Author URI: http://tixen.net/
License: GPL 2.0

	Copyright 2010,  Soleil Golden  (email : soleil@tixen.net)
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License, version 2, as 
	published by the Free Software Foundation.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// Produce the locally stored XML when requested...
if(isset($_GET['xml'])) { 
	require(dirname(__FILE__).'/../../../wp-blog-header.php');
	header('HTTP/1.1 200 OK');
	header ("Content-Type: text/xml");
	if(get_option('anyfeed_cache')){ 
		$handle = fopen(get_option('anyfeed_tempfile'), 'r');
		print(fread($handle, 10485760));
		fclose($handle);
	} else {
		$url=get_option('anyfeed_feed_url');
		if(empty($url)) update_option('anyfeed_feed_url', 'http://api.flickr.com/services/feeds/photos_public.gne?format=rss_200');
		$content="";
		$handle = fopen(get_option('anyfeed_feed_url'), 'r');
		if(!$handle){ die("Failed to open url".get_option('anyfeed_feed_url')); }
		while (!feof($handle)) { $content .= (fread($handle, 8192));}
		fclose($handle);
		if(preg_match('/flickr.com/', $url)) { /* Resize photos from Flickr */ print preg_replace('/(flickr.com\/[\d]*?\/[\d]*?_.*?_)s.((jpg|gif|png)") height="75" width="75"/', '$1m.$2', $content); }
		elseif(preg_match('/picasaweb.google.com/', $url)) { /* Resize photos from Google */ print preg_replace('/(media:thumbnail url=\'http:\/\/.*?\.ggpht\.com\/_.*?\/.*?\/.*?\/.*?\/s)160(-c\/.*?\.(jpg|gif|png)\' height=\')160(\' width=\')160(\')/', "\${1}240\${2}240\${4}240\${5}", $content);}
		else { print $content; }
	}
	die();
}

function path_to_anyfeed() {
	$path = (str_replace(basename(__FILE__), "", __FILE__));
	$path = end(explode("plugins/", $path));
	$path = str_replace("\\", "/", $path);
	if(end(explode("/",$path)) == 'mu-') {
		$path =	'/wp-content/mu-plugins/'.$path;
	} else {$path =	'/wp-content/plugins/'.$path;}
	return $path;
}


// Add the javascripts and CSS to the HTML head
add_action('wp_head', 'anyfeed_head' );
function anyfeed_head() {	


if(empty($_SERVER['HTTPS']) OR $_SERVER['HTTPS'] == 'off') $http = 'http://'; else $http = 'https://';
	
?>
	<!-- Begin Anyfeed Slideshow -->
		<link type="text/css" rel="stylesheet" href="<?php bloginfo('wpurl'); echo path_to_anyfeed(); ?>style.css" />
		<script type="text/javascript" src="<?php bloginfo('wpurl'); echo path_to_anyfeed(); ?>anyfeed.js"></script>
		<script type="text/javascript"> var anyfeed;
			jQuery(document).ready(function(){ anyfeed = new anyfeed_slideshow({
					pause_rate: <?php echo get_option('anyfeed_pause_rate');?>,
					fade_rate: <?php echo get_option('anyfeed_fade_rate');?>,
					media_type: '<?php echo get_option('anyfeed_media_type');?>',
					loading_text: '<?php echo addslashes(get_option('anyfeed_loading_text'));?>',
					title_bar: <?php if(get_option('anyfeed_show_titlebar')) echo 'true'; else echo 'false';?>,
					navigation: <?php if(get_option('anyfeed_show_navigation')) echo 'true'; else echo 'false';?>,
					c_width: '<?php echo get_option('anyfeed_width');?>',
					c_height: '<?php echo get_option('anyfeed_bgcolor');?>',
					c_height: '<?php echo get_option('anyfeed_height');?>',
					bgcolor: '<?php echo get_option('anyfeed_bgcolor');?>',
					xml_url: '<?php echo $http.$_SERVER['SERVER_NAME'].dirname($_SERVER['SCRIPT_NAME']).path_to_anyfeed().'anyfeed_slideshow.php?xml'; ?>',
					debug: false
			}); anyfeed.init(); });
		</script>
	<!-- End Anyfeed Slideshow -->
<?PHP
}


add_action( 'widgets_init', 'anyfeed_init' );
function anyfeed_init() { register_widget( 'anyfeed_slideshow' ); }
class anyfeed_slideshow extends WP_Widget {

		function anyfeed_slideshow() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'anyfeed', 'description' => 'XML/RSS/ATOM slideshow widget engine.  ' );
		/* Widget control settings. */
		$control_ops = array( 'width' => 245, 'height' => 200, 'id_base' => 'anyfeed' );

		/* Create the widget. */
		$this->WP_Widget( 'anyfeed', 'Anyfeed Slideshow', $widget_ops, $control_ops );

		wp_enqueue_script('jquery');
	}
		
	function widget( $args, $instance ) {
		extract( $args );
		
		// Drawing Title
		echo $before_widget . $before_title . $instance['title'] . $after_title;

		// Check tempfile to see if we need to create a new one or not
		if(get_option('anyfeed_cache')){ 
			$tempfile = get_option('anyfeed_tempfile');
			if(	empty($tempfile) OR // The tempfile filename is not set
				!file_exists($tempfile) OR // The file does not exist
				!get_option('anyfeed_cache') OR // Cache is not enabled
				time() - filemtime($tempfile) > (60*60*24) // Older then 24 hours
			) {
				@unlink(get_option('anyfeed_tempfile'));			
				$url = get_option('anyfeed_feed_url');
				if(empty($url)) {print('<div class="anyfeed_error">The URL was blank.  Did you enter one in the Widget settings?</div>'.$after_widget); return false;}
				$urla = explode("://", $url);
				if(isset($urla[1])) { $url = $urla[1]; }
				$url = 'http://'.$url;
				$temp_file = tempnam(sys_get_temp_dir(), 'ANY');
				if(!$f = @fopen($temp_file, 'w')){ print('<div class="anyfeed_error">Failed to open temp file.</div>'.$after_widget); return false;}
				update_option('anyfeed_tempfile', $temp_file);
				$f = fopen($temp_file, 'w');	
				if(function_exists('curl_init')){
					if(!$c = @curl_init($url)){ print('<div class="anyfeed_error">Failed to open the HTTP stream.</div>'.$after_widget); return false; }
	
					curl_setopt($c, CURLOPT_BINARYTRANSFER, true);
	
					curl_setopt($c, CURLOPT_FAILONERROR, true);
	
					curl_setopt($c, CURLOPT_FORBID_REUSE, true);
	
					curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
	
					curl_setopt($c, CURLOPT_AUTOREFERER, true);
	
					$tmpxml = curl_exec($c);
					$there_was_an_error = curl_errno($c);
					$error_text = curl_error($c);
	
					curl_close($c);
					if($there_was_an_error) { print('<div class="anyfeed_error"> An error ocurred during feed transmission: <br />'.$error_text.'</div>'.$after_widget); return false; }
					if(preg_match('/flickr.com/', $url)) { /* Resize photos from Flickr */ $tmpxml = preg_replace('/(flickr.com\/[\d]*?\/[\d]*?_.*?_)s.((jpg|gif|png)") height="75" width="75"/', '$1m.$2', $tmpxml); }
					if(preg_match('/picasaweb.google.com/', $url)) { /* Resize photos from Google */ $tmpxml = preg_replace('/(media:thumbnail url=\'http:\/\/.*?\.ggpht\.com\/_.*?\/.*?\/.*?\/.*?\/s)160(-c\/.*?\.(jpg|gif|png)\' height=\')160(\' width=\')160(\')/', "\${1}240\${2}240\${4}240\${5}", $tmpxml);}
				} else {
					if(!$c = @fopen($url, r)){print('<div class="anyfeed_error">Failed to open the HTTP stream.</div>'.$after_widget); return false;}
					if(!$tmpxml = stream_get_contents($c)){print('<div class="anyfeed_error">Failed to download the XML file.</div>.$after_widget'); return false;}
					@fclose($c);
				}
				if(!@fwrite($f, $tmpxml)){ fclose($f); print('<div class="anyfeed_error">Failed to write XML. <textarea>'.$tmpxml.'</textarea></div>'.$after_widget); return false;}
				fclose($f);
			}// end cache if
		}// End if cache
		// Drawing Widget
		echo '<div id="anyfeed_slideshow_main"></div>';
		echo $after_widget;
	}
	
		
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		/* Strip tags (if needed) and update the widget settings. */
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['width'] = strip_tags( $new_instance['width'] ); update_option('anyfeed_width', $instance['width']);
		$instance['height'] = strip_tags( $new_instance['height'] );update_option('anyfeed_height', $instance['height']);
		$instance['feed_url'] = $new_instance['feed_url']; update_option('anyfeed_feed_url', $instance['feed_url']);
		if($new_instance['show_titlebar'] == 'on') { $new_instance['show_titlebar'] = true; } else { $new_instance['show_titlebar'] = false; }
		$instance['show_titlebar'] = $new_instance['show_titlebar']; update_option('anyfeed_show_titlebar', $instance['show_titlebar']);
		if($new_instance['show_navigation'] == 'on') { $new_instance['show_navigation'] = true; } else { $new_instance['show_navigation'] = false; }
		$instance['show_navigation'] = $new_instance['show_navigation']; update_option('anyfeed_show_navigation', $instance['show_navigation']);
		$instance['pause_rate'] = $new_instance['pause_rate']; update_option('anyfeed_pause_rate', $instance['pause_rate']);
		$instance['fade_rate'] = $new_instance['fade_rate']; update_option('anyfeed_fade_rate', $instance['fade_rate']);
		$instance['loading_text'] = $new_instance['loading_text']; update_option('anyfeed_loading_text', $instance['loading_text']);
		$instance['media_type'] = $new_instance['media_type']; update_option('anyfeed_media_type', $instance['media_type']);
		$instance['bgcolor'] = $new_instance['bgcolor']; update_option('anyfeed_bgcolor', $instance['bgcolor']);
		if($new_instance['cache'] == 'on') { $new_instance['cache'] = true; } else { $new_instance['cache'] = false; }
		$instance['cache'] = $new_instance['cache']; update_option('anyfeed_cache', $instance['cache']);
		return $instance;
	}


	function form( $instance ) {
		print(
			'<a href="http://tixen.net/projects/anyfeed-slideshow" target="_blank"><img src="'.get_bloginfo('wpurl').path_to_anyfeed().'logo.jpg" alt="" style="float: right; border: none;"></a>'."\r\n".
			'<p style="line-height: 105%; text-align: center;">
				<small>
					(Hover your mouse over the label text for a short description 
					of the corresponding field)
				</small>
			</p>'."\r\n");
		/* Default Widget Settings. */
		$defaults = array( 
			'title' 	=> 'Anyfeed Slideshow', 
			'width' 	=> '100%',
			'height'	=> '200px',
			'feed_url'	=> 'http://api.flickr.com/services/feeds/photos_public.gne?format=rss_200',
			'show_titlebar' => true,
			'show_navigation' => true,
			'pause_rate' => 5000,
			'fade_rate'	=> 1000,
			'loading_text' => 'Loading...',
			'media_type' => 'thumbnail',
			'bgcolor' => 'transparent',
			'cache' => false
			
		);
		$instance = wp_parse_args( $instance, $defaults ); 
		 wp_enqueue_script("jquery");
		 ?>
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>" title="The text that will appear above the slideshow in the sidebar.">Title:</label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" style="width:90%;" />
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'feed_url' ); ?>" title="The URL to the feed to get photos from.">Feed URL:</label>
			<input id="<?php echo $this->get_field_id( 'feed_url' ); ?>" name="<?php echo $this->get_field_name( 'feed_url' ); ?>" value="<?php echo $instance['feed_url']; ?>" style="width:90%;" />
		</p>
		
		<div onclick="jQuery('div#anyfeed_advanced').slideToggle();" class="button" style="text-align: center; margin: 5px auto 0;">Show/Hide Advanced Options</div>
		<div id="anyfeed_advanced" style="display: none;">
		<table width="95%"><tr><td width="50%">
			<p>
				<label for="<?php echo $this->get_field_name( 'height' ); ?>" title="The height of the slideshow window.">Height:</label>
				<input id="<?php echo $this->get_field_id( 'height' ); ?>" name="<?php echo $this->get_field_name( 'height' ); ?>" value="<?php echo $instance['height']; ?>" style="width:90%;" />
			</p>
		</td><td width="5%"></td><td>
			<p>
				<label for="<?php echo $this->get_field_id( 'width' ); ?>" title="The width of the slideshow window.">Width:</label>
				<input id="<?php echo $this->get_field_id( 'width' ); ?>" name="<?php echo $this->get_field_name( 'width' ); ?>" value="<?php echo $instance['width']; ?>" style="width:90%;" />
			</p>
		</td></tr></table>
		<p>
			<label for="<?php echo $this->get_field_id( 'media_type' ); ?>" title="If the feed URL is of a media type, select whether to display thumbnail (recommended) or content (the full sized original file).  For Flickr and Picasa feeds, leave this set to thumbnail.">Feed Media Type:</label>
			<select id="<?php echo $this->get_field_id( 'media_type' ); ?>" name="<?php echo $this->get_field_name( 'media_type' ); ?>" class="widefat" style="width:90%;">
				<option <?php if ( 'content' == $instance['media_type'] ) echo 'selected="selected"'; ?>>content</option>
				<option <?php if ( 'thumbnail' == $instance['media_type'] ) echo 'selected="selected"'; ?>>thumbnail</option>
			</select>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'loading_text' ); ?>" title="The text that pulses while the images are being cached.">Loading Text:</label>
			<input id="<?php echo $this->get_field_id( 'loading_text' ); ?>" name="<?php echo $this->get_field_name( 'loading_text' ); ?>" value="<?php echo $instance['loading_text']; ?>" style="width:90%;" />
		</p>
		
		<table width="95%"><tr><td width="50%">
			<p>
				<label for="<?php echo $this->get_field_id( 'pause_rate' ); ?>" title="The length of time the slideshow will pause on a photo.">Pause delay (milliseconds):</label>
				<input id="<?php echo $this->get_field_id( 'pause_rate' ); ?>" name="<?php echo $this->get_field_name( 'pause_rate' ); ?>" value="<?php echo $instance['pause_rate']; ?>" style="width:90%;" />
			</p>
		</td><td width="5%"></td><td>	
			<p>
				<label for="<?php echo $this->get_field_id( 'fade_rate' ); ?>" title="The length of time of the fade effect.">Fade time (milliseconds):</label>
				<input id="<?php echo $this->get_field_id( 'fade_rate' ); ?>" name="<?php echo $this->get_field_name( 'fade_rate' ); ?>" value="<?php echo $instance['fade_rate']; ?>" style="width:100%;" />
			</p>
		</td></tr></table>
		
		<p>
			<input class="checkbox" type="checkbox" <?php checked( $instance['show_navigation'], true ); ?> id="<?php echo $this->get_field_id( 'show_navigation' ); ?>" name="<?php echo $this->get_field_name( 'show_navigation' ); ?>" />
			<label for="<?php echo $this->get_field_id( 'show_navigation' ); ?>" title="Whether or not to show the back and forward arrows when mousing over the slideshow.">Show Navigation?</label>
		</p>
		
		<p>
			<input class="checkbox" type="checkbox" <?php checked( $instance['show_titlebar'], true ); ?> id="<?php echo $this->get_field_id( 'show_titlebar' ); ?>" name="<?php echo $this->get_field_name( 'show_titlebar' ); ?>" />
			<label for="<?php echo $this->get_field_id( 'show_titlebar' ); ?>"title="Whether or not to show the title of the image when mousing over the slideshow.">Show Titlebar?</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'bgcolor' ); ?>" title="The background color of slideshow.">Background Color:</label>
			<input id="<?php echo $this->get_field_id( 'bgcolor' ); ?>" name="<?php echo $this->get_field_name( 'bgcolor' ); ?>" value="<?php echo $instance['bgcolor']; ?>" style="width:90%;" />
		</p>
		<p>
		
			<input class="checkbox" type="checkbox" id="<?php echo $this->get_field_id( 'cache' ); ?>" name="<?php echo $this->get_field_name( 'cache' ); ?>" <?PHP  
			if(@is_writable(@sys_get_temp_dir())) {  checked( $instance['cache'], true ); ?>/>
			<label for="<?php echo $this->get_field_id( 'cache' ); ?>" title="Whether or not to cache the downloaded XML for 24 hours (faster page loads, but slower between udpates).">Cache XML for 24 hours?</label>
		<?PHP } else { update_option('anyfeed_cache', false); ?> disabled="disabled" />
			<label for="<?php echo $this->get_field_id( 'cache' ); ?>" title="Whether or not to cache the downloaded XML for 24 hours.  NOTE: This feature requires access to the temp directory, which your hosting provider does not allow."><span style="color: #bbbbbb;">Cache XML for 24 hours?</span> This feature is not compatible with your Host's configuration.</label>
		<?PHP } ?>
		</p>
		</div>
		<?PHP
	} // End Form
} // End class

if ( function_exists('register_deactivation_hook') ) register_deactivation_hook(__FILE__, 'anyfeed_clear_hook');

function anyfeed_clear_hook() {
	$tempfile = get_option('anyfeed_tempfile');
	if(	!empty($tempfile) AND file_exists($tempfile) ) @unlink($tempfile);
	
	delete_option('anyfeed_width');
	delete_option('anyfeed_height');
	delete_option('anyfeed_feed_url');
	delete_option('anyfeed_show_titlebar');
	delete_option('anyfeed_show_navigation');
	delete_option('anyfeed_pause_rate');
	delete_option('anyfeed_fade_rate');
	delete_option('anyfeed_loading_text');
	delete_option('anyfeed_media_type');
	delete_option('anyfeed_bgcolor');
	delete_option('anyfeed_cache');
	delete_option('anyfeed_tempfile');
	delete_option('widget_anyfeed');
}




?>